]> git.donarmstrong.com Git - deb_pkgs/autorandr.git/blobdiff - autorandr
Python version: Added error messages
[deb_pkgs/autorandr.git] / autorandr
index 143a04450babaf8d7bbe25b4ceb77d49ca9069ed..1b7c16e44f36af62ddcd9eaaf60e8d77ef424b8e 100755 (executable)
--- a/autorandr
+++ b/autorandr
@@ -2,52 +2,34 @@
 #
 # Automatically select a display configuration based on connected devices
 #
-# Stefan Tomanek <stefan.tomanek@wertarbyte.de>
+# autorandr was originally written by Stefan Tomanek <stefan.tomanek@wertarbyte.de>
+# For licensing reasons, this version does not contain non-trivial code from the
+# original version and from authors that did not consent with OSS licensing this
+# program.
 #
-# How to use:
 #
-# Save your current display configuration and setup with:
-#  $ autorandr --save mobile
 #
-# Connect an additional display, configure your setup and save it:
-#  $ autorandr --save docked
+# THE FOLLOWING LICENCE AGREEMENT IS PRELIMINARY AND INVALID UNTIL ISSUE #7 AT
+#  https://github.com/phillipberndt/autorandr/issues/7
+# HAS BEEN RESOLVED!
 #
-# Now autorandr can detect which hardware setup is active:
-#  $ autorandr
-#    mobile
-#    docked (detected)
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
 #
-# To automatically reload your setup, just append --change to the command line
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
 #
-# To manually load a profile, you can use the --load <profile> option.
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
-# autorandr tries to avoid reloading an identical configuration. To force the
-# (re)configuration, apply --force.
-#
-# To prevent a profile from being loaded, place a script call "block" in its
-# directory. The script is evaluated before the screen setup is inspected, and
-# in case of it returning a value of 0 the profile is skipped. This can be used
-# to query the status of a docking station you are about to leave.
-#
-# If no suitable profile can be identified, the current configuration is kept.
-# To change this behaviour and switch to a fallback configuration, specify
-# --default <profile>
-#
-# Another script called "postswitch "can be placed in the directory
-# ~/.autorandr as well as in all profile directories: The scripts are executed
-# after a mode switch has taken place and can notify window managers or other
-# applications about it.
-#
-#
-# While the script uses xrandr by default, calling it by the name "autodisper"
-# or "auto-disper" forces it to use the "disper" utility, which is useful for
-# controlling nvidia chipsets. The formats for fingerprinting the current setup
-# and saving/loading the current configuration are adjusted accordingly.
 
 XRANDR=/usr/bin/xrandr
 DISPER=/usr/bin/disper
-XDPYINFO=/usr/bin/xdpyinfo
-PROFILES=~/.autorandr/
+PROFILES=~/.autorandr
 CONFIG=~/.autorandr.conf
 RESERVED_PROFILE_NAMES=`cat <<EOF
  common     Clone all connected outputs at the largest common resolution
@@ -68,7 +50,6 @@ SCRIPTNAME="$(basename $0)"
 # when called as autodisper/auto-disper, we assume different defaults
 if [ "$SCRIPTNAME" = "auto-disper" ] || [ "$SCRIPTNAME" = "autodisper" ]; then
        echo "Assuming disper defaults..." >&2
-       FP_METHODS="setup_fp_disper"
        CURRENT_CFG_METHOD="current_cfg_disper"
        LOAD_METHOD="load_cfg_disper"
 fi
@@ -80,50 +61,48 @@ fi
 
 setup_fp_xrandr_edid() {
        $XRANDR -q --verbose | awk '
-       /^[^ ]+ (dis)?connected / { DEV=$1; }
-       $1 ~ /^[a-f0-9]+$/ { ID[DEV] = ID[DEV] $1 }
-       END { for (X in ID) { print X " " ID[X]; } }'
+       ORS="";
+       / (dis)?connected/ { DEVICE=gensub("-([A-Z]-)?", "", "g", $1) " "; }
+       /^[[:blank:]]+EDID:/ {
+               print DEVICE
+               DEVICE=""
+               for(getline; /^[[:blank:]]+[0-9a-f]+$/; getline) {
+                       print $1;
+               }
+               print "\n";
+       }
+       END {
+               print "\n";
+       }
+       '
 }
 
 setup_fp_sysfs_edid() {
-       # xrandr triggers the reloading of EDID data
+       which xxd >/dev/null 2>&1 || return
        $XRANDR -q > /dev/null
-       # hash the EDIDs of all _connected_ devices
-       for P in /sys/class/drm/card*-*/; do
-               # nothing found
-               [ ! -d "$P" ] && continue
-               if grep -q "^connected$" < "${P}status"; then
-                       echo -n "$(basename "$P") "
-                       md5sum ${P}edid | awk '{print $1}'
-               fi
+       for DEVICE in /sys/class/drm/card*-*; do
+               [ -e "${DEVICE}/status" ] && grep -q "^connected$" "${DEVICE}/status" || continue
+               echo -n "$(echo "${DEVICE}/edid" | sed -re 's#^.+card[0-9]+-([^/]+).+#\1#; s#-([A-Z]-)?##') "
+                       xxd -c 256 -ps "${DEVICE}/edid" | awk 'ORS=""; /.+/ { print; }'
+               echo
        done
 }
 
-setup_fp_disper() {
-       $DISPER -l | grep '^display '
-}
-
 setup_fp() {
-       local FP="";
-       for M in $FP_METHODS; do
-               FP="$($M)"
-               if [ -n "$FP" ]; then
-                       break
-               fi
+       FINGERPRINT=""
+       for METHOD in $FP_METHODS; do
+               FINGERPRINT="$($METHOD)"
+               [ -n "$FINGERPRINT" ] && break
        done
-       if [ -z "$FP" ]; then
-               echo "Unable to fingerprint display configuration" >&2
-               return
+       if [ -z "$FINGERPRINT" ]; then
+               echo "Unable to fingerprint display configuration." >&2
+               return 0
        fi
-       echo "$FP"
+       echo "$FINGERPRINT" | sort
 }
 
 current_cfg_xrandr() {
-       local PRIMARY_SETUP="";
-       if [ -x "$XDPYINFO" ]; then
-               PRIMARY_SETUP="$($XDPYINFO -ext XINERAMA | awk '/^  head #0:/ {printf $3 $5}')"
-       fi
-       $XRANDR -q | awk -v primary_setup="${PRIMARY_SETUP}" '
+       $XRANDR -q | awk '
        # display is connected and has a mode
        /^[^ ]+ connected [^(]/ {
                print "output "$1;
@@ -134,8 +113,6 @@ current_cfg_xrandr() {
                }
                else {
                        split($3, A, "+");
-                       if (A[1] A[2] "," A[3] == primary_setup)
-                               print "primary";
                }
                if (($4 == "left") || ($4 == "right")) {
                        split(A[1], B, "x");
@@ -258,45 +235,52 @@ current_cfg() {
 }
 
 blocked() {
-       local PROFILE="$1"
-       [ ! -x "$PROFILES/$PROFILE/block" ] && return 1
-
-       "$PROFILES/$PROFILE/block" "$PROFILE"
+       [ ! -x "$PROFILES/$1/block" ] && return 1
+       "$PROFILES/$1/block" "$1"
 }
 
 config_equal() {
-       local PROFILE="$1"
-       if [ "$(cat "$PROFILES/$PROFILE/config")" = "$(current_cfg)" ]; then
-               echo "Config already loaded"
+       if [ "$(cat "$PROFILES/$1/config")" = "$(current_cfg)" ]; then
+               echo "Config already loaded." >&2
                return 0
-       else
-               return 1
        fi
+       return 1
 }
 
 load_cfg_xrandr() {
        # sed 1: Prefix arguments with "--"
        # sed 2: Merge arguments into one line per output
-       # sed 3: Merge into two lines, all --off outputs in the first one
+       # sed 3:  * Merge all --off outputs into the first line
+       #         * Place the output with --pos 0x0 on the second line
+       #         * Remaining outputs are appended as they appear
+       #         * Keep everything in hold buffer until the last line
+       # sed 4: Remove empty lines caused by G and H on empty hold buffer
+       # sed 5: Join lines enabling screens in pairs of two (See https://github.com/phillipberndt/autorandr/pull/6)
        sed 's/^/--/' "$1" | sed -e '
                :START
                /\n--output/{P;D}
                s/\n/ /
                N;bSTART' | sed -e '
-                       ### First line
                        / --off/{
                                G
-                               # Merge if next line contains --off
+                               # Merge with next line if it contains --off
                                s/\n\([^\n]* --off\)/ \1/
                                h
                                $!d;b
                        }
-                       ### Last line
-                       H;x
-                       # Merge if previous line contains --mode
-                       s/\(--mode [^\n]*\)\n/\1 /
-                       h
-                       $!d' | xargs -L 1 $XRANDR
+                       / --pos 0x0/{
+                               G
+                               # Swap lines 1 and 2 if --off is found
+                               / --off/ s/^\([^\n]*\)\n\([^\n]*\)/\2\n\1/
+                               h
+                               $!d;b
+                       }
+                       H
+                       $!d
+                       x' | sed -e '
+                               /./ !d' | sed -e '
+                                       /--mode/{ N; s/\n/ /; }
+                               ' | xargs -L 1 $XRANDR
 }
 
 load_cfg_disper() {
@@ -370,12 +354,13 @@ Usage: $SCRIPTNAME [options]
  To change this behaviour and switch to a fallback configuration, specify
  --default <profile>.
 
- Another script called "postswitch "can be placed in the directory
+ Another script called "postswitchcan be placed in the directory
  ~/.autorandr as well as in any profile directories: The scripts are executed
- after a mode switch has taken place and can notify window managers.
+ after a mode switch has taken place and can notify window managers. The same
+ goes for "preswitch", which will be executed before a mode switch.
 
  When called by the name "autodisper" or "auto-disper", the script uses "disper"
- instead of "xrandr" to detect, configure and save the display configuration.
+ instead of "xrandr" to configure and save the display configuration.
 
  If xrandr is used, the following virtual configurations are available:
 ${RESERVED_PROFILE_NAMES}
@@ -422,11 +407,11 @@ if [ -n "$LOAD_PROFILE" ]; then
        exit $?
 fi
 
-for SETUP_FILE in $PROFILES/*/setup; do
-       if ! [ -e $SETUP_FILE ]; then
-               break
-       fi
-       PROFILE="$(basename $(dirname "$SETUP_FILE"))"
+for PROFILE_PATH in $PROFILES/*; do
+       PROFILE="$(basename "$PROFILE_PATH")"
+       SETUP_FILE="${PROFILE_PATH}/setup"
+
+       [ -e $SETUP_FILE ] || continue
        echo -n "$PROFILE"
 
        if blocked "$PROFILE"; then
@@ -434,7 +419,27 @@ for SETUP_FILE in $PROFILES/*/setup; do
                continue
        fi
 
-       FILE_SETUP="$(cat "$PROFILES/$PROFILE/setup")"
+       # This sed command is for compatibility with old versions that did not try
+       # to normalize device names
+       FILE_SETUP="$(sed -re 's#-([A-Z]-)?##g; s#card[0-9]##;' "$PROFILES/$PROFILE/setup")"
+       # Detect the md5sum in fingerprint files created using the old sysfs fingerprinting
+       # If it is detected, output a warning and calculate the legacy variant of the current
+       # setup.
+       if echo "$FILE_SETUP" | grep -Eq "^[^ ]+ [0-9a-f]{32}$"; then
+               echo -n " (Obsolete fingerprint format. Please update using --save.) "
+
+               if [ -z "$LEGACY_CURRENT_SETUP" ]; then
+                       LEGACY_CURRENT_SETUP="$(echo "$CURRENT_SETUP" | while read DEVICE EDID; do
+                               echo -n "${DEVICE} "
+                               echo -n "${EDID}" | xxd -r -ps | md5sum - | awk '{print $1}'
+                       done)"
+               fi
+               FILE_SETUP="$(echo "$FILE_SETUP" | sort)"
+               if [ "$LEGACY_CURRENT_SETUP" = "$FILE_SETUP" ]; then
+                       CURRENT_SETUP="$LEGACY_CURRENT_SETUP"
+               fi
+       fi
+
        if [ "$CURRENT_SETUP" = "$FILE_SETUP" ]; then
                echo " (detected)"
                if [ "$CHANGE_PROFILE" -eq 1 ]; then